/*
 * This file was automatically generated by oml2-scaffold V2.11.0
 * for wattsup version 2.11.0.
 * Please do not edit.
 */

#ifndef WATTSUP_OML_H
#define WATTSUP_OML_H

#ifdef __cplusplus
extern "C" {
#endif

/* Define HUGE, etc.. */
#define _GNU_SOURCE
#include <math.h>
/* Get size_t and NULL from <stddef.h> */
#include <stddef.h>

#include <oml2/omlc.h>

typedef struct {
  OmlMP *power;
  OmlMP *cost;
  OmlMP *monthly;
  OmlMP *maxima;
  OmlMP *minima;
  OmlMP *meta;

} oml_mps_t;


#ifdef OML_FROM_MAIN
/*
 * Only declare storage once, usually from the main
 * source, where OML_FROM_MAIN is defined
 */

static OmlMPDef oml_power_def[] = {
  {"power", OML_DOUBLE_VALUE},
  {"voltage", OML_DOUBLE_VALUE},
  {"current", OML_DOUBLE_VALUE},
  {"energy", OML_DOUBLE_VALUE},
  {"frequency", OML_DOUBLE_VALUE},
  {"apparent_power", OML_DOUBLE_VALUE},
  {NULL, (OmlValueT)0}
};

static OmlMPDef oml_cost_def[] = {
  {"cost", OML_DOUBLE_VALUE},
  {NULL, (OmlValueT)0}
};

static OmlMPDef oml_monthly_def[] = {
  {"energy", OML_DOUBLE_VALUE},
  {"cost", OML_DOUBLE_VALUE},
  {NULL, (OmlValueT)0}
};

static OmlMPDef oml_maxima_def[] = {
  {"power", OML_DOUBLE_VALUE},
  {"voltage", OML_DOUBLE_VALUE},
  {"current", OML_DOUBLE_VALUE},
  {NULL, (OmlValueT)0}
};

static OmlMPDef oml_minima_def[] = {
  {"power", OML_DOUBLE_VALUE},
  {"voltage", OML_DOUBLE_VALUE},
  {"current", OML_DOUBLE_VALUE},
  {NULL, (OmlValueT)0}
};

static OmlMPDef oml_meta_def[] = {
  {"power_factor", OML_INT32_VALUE},
  {"duty_cycle", OML_INT32_VALUE},
  {"power_cycle", OML_INT32_VALUE},
  {NULL, (OmlValueT)0}
};

static oml_mps_t g_oml_mps_storage;
oml_mps_t* g_oml_mps_wattsup = &g_oml_mps_storage;

static inline void
oml_register_mps(void)
{
  g_oml_mps_wattsup->power = omlc_add_mp("power", oml_power_def);
  g_oml_mps_wattsup->cost = omlc_add_mp("cost", oml_cost_def);
  g_oml_mps_wattsup->monthly = omlc_add_mp("monthly", oml_monthly_def);
  g_oml_mps_wattsup->maxima = omlc_add_mp("maxima", oml_maxima_def);
  g_oml_mps_wattsup->minima = omlc_add_mp("minima", oml_minima_def);
  g_oml_mps_wattsup->meta = omlc_add_mp("meta", oml_meta_def);

}

#else
/*
 * Not included from the main source, only declare the global pointer
 * to the MPs and injection helpers.
 */

extern oml_mps_t* g_oml_mps_wattsup;

#endif /* OML_FROM_MAIN */

static inline int
oml_inject_power(OmlMP *mp, double power, double voltage, double current, double energy, double frequency, double apparent_power)
{
  int ret = -1;

  OmlValueU v[6];
  omlc_zero_array(v, 6);

  omlc_set_double(v[0], power);
  omlc_set_double(v[1], voltage);
  omlc_set_double(v[2], current);
  omlc_set_double(v[3], energy);
  omlc_set_double(v[4], frequency);
  omlc_set_double(v[5], apparent_power);

  ret = omlc_inject(mp, v);

  return ret;
}

static inline int
oml_inject_cost(OmlMP *mp, double cost)
{
  int ret = -1;

  OmlValueU v[1];
  omlc_zero_array(v, 1);

  omlc_set_double(v[0], cost);

  ret = omlc_inject(mp, v);

  return ret;
}

static inline int
oml_inject_monthly(OmlMP *mp, double energy, double cost)
{
  int ret = -1;

  OmlValueU v[2];
  omlc_zero_array(v, 2);

  omlc_set_double(v[0], energy);
  omlc_set_double(v[1], cost);

  ret = omlc_inject(mp, v);

  return ret;
}

static inline int
oml_inject_maxima(OmlMP *mp, double power, double voltage, double current)
{
  int ret = -1;

  OmlValueU v[3];
  omlc_zero_array(v, 3);

  omlc_set_double(v[0], power);
  omlc_set_double(v[1], voltage);
  omlc_set_double(v[2], current);

  ret = omlc_inject(mp, v);

  return ret;
}

static inline int
oml_inject_minima(OmlMP *mp, double power, double voltage, double current)
{
  int ret = -1;

  OmlValueU v[3];
  omlc_zero_array(v, 3);

  omlc_set_double(v[0], power);
  omlc_set_double(v[1], voltage);
  omlc_set_double(v[2], current);

  ret = omlc_inject(mp, v);

  return ret;
}

static inline int
oml_inject_meta(OmlMP *mp, int32_t power_factor, int32_t duty_cycle, int32_t power_cycle)
{
  int ret = -1;

  OmlValueU v[3];
  omlc_zero_array(v, 3);

  omlc_set_int32(v[0], power_factor);
  omlc_set_int32(v[1], duty_cycle);
  omlc_set_int32(v[2], power_cycle);

  ret = omlc_inject(mp, v);

  return ret;
}


/* Compatibility with old applications */
#ifndef g_oml_mps
# define g_oml_mps	g_oml_mps_wattsup
#endif

#ifdef __cplusplus
}
#endif

#endif /* WATTSUP_OML_H */
